#include <bits/stdc++.h>

using namespace std;

int main()
{
    long long int n, q, a, b, broj, i, j;

    cin>>n>>q;

    long long int niz[n];

    for(i=0; i<n; i++)
    {
        cin>>niz[i];
    }

    for(i=0; i<q; i++)
    {
        cin>>a>>b;

        broj=niz[a-1];

        for(j=a; j<b; j++)
        {
            broj=broj&niz[j];
        }

        cout<<broj<<endl;
    }

    return 0;
}